<?php
/*
Plugin Name: Mount Olive OP Archives
Plugin URI: http://rinaldo.net/projects/mount-olive-op-archives
Description: Insert links to Olive Press archived PDF files based on date and availablity
Version: 1.0.2
Date: 18 February 2019
Author: Bery Rinaldo <bery@rinaldo.net>
Author URI: http://rinaldo.net/
*/

/*
	Copyright 2019 Bery Rinaldo

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation. A copy of the license is at
	http://www.gnu.org/licenses/gpl-2.0.html

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
*/

/*
Note: This plugin requires WordPress version 4.3.1 or higher.

Information about the this plugin along with
instructions and examples can be found here:

http://rinaldo.net/projects/mount-olive-op-archives

Shortcode format:

[op_archive]
*/

#define( 'WP_DEBUG', true );


if( ! function_exists('bjrsu_op_archive') )
{

	function bjrsu_op_archive($content)
	{
		$message = array();
		$bjrsu_content = $content;
		preg_match_all('!\[op_archive\]!is',$bjrsu_content,$bjrsu_matches);
		$bjrsu_nummatches = count($bjrsu_matches[0]);
		if ($bjrsu_nummatches > 0)
		{
			$hp = ABSPATH;
			$motop = "mo-media/op";
			$top = dir("$hp/$motop");
			while($year = $top->read())
			{
				if ($year == "." || $year == "..") continue;
				if (is_dir("$hp/$motop/$year"))
				{
					$mid = dir("$hp/$motop/$year");
					while($month = $mid->read())
					{
						if ($month == "." || $month == "..") continue;
						if (is_dir("$hp/$motop/$year/$month"))
						{
							$low = dir("$hp/$motop/$year/$month");
							while($file = $low->read())
							{
								if ($file[0] != ".")
								{
									$path = "$motop/$year/$month/$file";
									$message[$messagecount] = $path;
									$messagecount++;
								}
							}
							$low->close();
						}
					}
					$mid->close();
				}
			}
			$top->close();
			rsort($message);
		}

		for( $bjrsu_i=0; $bjrsu_i<$bjrsu_nummatches; $bjrsu_i++ )
		{
			$bjrsu_replacement = "";

			if ($messagecount > 0)
			{
				$lastyear = "";
				$lastmonth = "";
				$didone = 0;
				$first = 1;
				for ($i=0; $i < $messagecount; $i++)
				{
					$path = $message[$i];
					$ret = preg_match("/.*\/(\d{4})\/(\d{2})\/OP-\d{4}-\d{2}-(\d{2}).pdf/",$path,$ymd);
					if ($ymd[1] !== $lastyear)
					{
						$lastyear = $ymd[1];
						$lastmonth = "";
						$didone = 0;
					}
					if ($ymd[2] !== $lastmonth)
					{
						if ($first == 0)
						{
							$bjrsu_replacement .= "<br>";
						}
						$bjrsu_replacement .= date("F",mktime(0,0,0,$ymd[2])) . "&nbsp;$ymd[1]&nbsp;";
						$lastmonth = $ymd[2];
						$didone = 0;
						$first = 0;
					}
					$dp = $ymd[3] + 0;  # strip leading zero
					if ($didone == 1)
					{
						$bjrsu_replacement .= ",";
					}
					$bjrsu_replacement .= "&nbsp;<a href=\"/$path\">$dp</a>";
					$didone = 1;
				}
			}
			else
			{
				$bjrsu_replacement = "<!-- no archived Olive Press files found -->";
			}

			$bjrsu_content = preg_replace('/'.preg_quote($bjrsu_matches[0][$bjrsu_i],'/').'/',$bjrsu_replacement,$bjrsu_content,1);
		}

		return $bjrsu_content;
	}
	add_filter( 'the_content', 'bjrsu_op_archive', 9 );

} # if( ! function_exists('bjrsu_op_archive') )

?>
